## libvcflib 1.0.3+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
project(vcflib)

include(ExternalProject)
include(FeatureSummary)

find_package(PkgConfig REQUIRED)

include(FindBZip2)
include(FindLibLZMA)
include(FindZLIB)

feature_summary(
  FATAL_ON_MISSING_REQUIRED_PACKAGES
  WHAT REQUIRED_PACKAGES_NOT_FOUND)

# ---- Options

option(BUILD_DOC "Build documentation" ON)
option(OPENMP "Enable OpenMP" OFF)
option(PROFILING "Enable profiling" OFF)
option(GPROF "Enable gprof profiling" OFF)

# ---- Dependencies

find_package(ZLIB)
set_package_properties(ZLIB PROPERTIES TYPE REQUIRED)
#find_package(LIBLZMA)
#set_package_properties(LIBLZMA PROPERTIES TYPE REQUIRED)
find_package(Threads)
set_package_properties(Threads PROPERTIES TYPE REQUIRED)

pkg_check_modules(HTSLIB htslib)
pkg_check_modules(TABIXPP tabixpp) # Optional

# ---- Build switches

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -std=c++0x -D_FILE_OFFSET_BITS=64 -Isrc -O3")

if(OPENMP)
  find_package(OpenMP REQUIRED)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
endif(OPENMP)

if(PROFILING)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g")
endif(PROFILING)

if(GPROF)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pg")
endif(GPROF)

# ---- Include files

include_directories(include)
include_directories(fastahack)
include_directories(intervaltree)
include_directories(smithwaterman)
include_directories(multichoose)
include_directories(filevercmp)

if(HTSLIB_LOCAL)
  include_directories(
  ${HTSLIB_LOCAL}
  tabixpp/htslib
  contrib/htslib)
endif(HTSLIB_LOCAL)

file(GLOB INCLUDES
  src/*.h*
  multichoose/*.h*
  intervaltree/*.h*
  smithwaterman/*.h*
  fastahack/*.h*
  filevercmp/*.h*)

add_library(vcflib STATIC
    src/Variant.h
    src/split.h
    src/pdflib.hpp
    src/var.hpp
    src/cdflib.hpp
    src/rnglib.hpp
    src/join.h
    src/Variant.cpp
    src/rnglib.cpp
    src/var.cpp
    src/pdflib.cpp
    src/cdflib.cpp
    src/split.cpp
    src/ssw.hpp
    src/ssw_cpp.hpp
    fastahack/Fasta.cpp
    smithwaterman/SmithWatermanGotoh.cpp
    smithwaterman/Repeats.cpp
    smithwaterman/IndelAllele.cpp
    smithwaterman/disorder.cpp
    smithwaterman/LeftAlign.cpp
    fsom/fsom.c
    filevercmp/filevercmp.c
    )

set(BINS
    vcfecho
    dumpContigsFromHeader
    bFst
    pVst
    hapLrt
    popStats
    wcFst
    iHS
    segmentFst
    segmentIhs
    genotypeSummary
    sequenceDiversity
    pFst
    smoother
    vcfld
    plotHaps
    abba-baba
    permuteGPAT++
    permuteSmooth
    normalize-iHS
    meltEHH
    vcfaltcount
    vcfhetcount
    vcfhethomratio
    vcffilter
    vcf2tsv
    vcfgenotypes
    vcfannotategenotypes
    vcfcommonsamples
    vcfremovesamples
    vcfkeepsamples
    vcfsamplenames
    vcfgenotypecompare
    vcffixup
    vcfclassify
    vcfsamplediff
    vcfremoveaberrantgenotypes
    vcfrandom
    vcfparsealts
    vcfstats
    vcfflatten
    vcfprimers
    vcfnumalt
    vcfcleancomplex
    vcfintersect
    vcfannotate
    vcfallelicprimitives
    vcfoverlay
    vcfaddinfo
    vcfkeepinfo
    vcfkeepgeno
    vcfafpath
    vcfcountalleles
    vcflength
    vcfdistance
    vcfrandomsample
    vcfentropy
    vcfglxgt
    vcfroc
    vcfcheck
    vcfstreamsort
    vcfuniq
    vcfuniqalleles
    vcfremap
    vcf2fasta
    vcfsitesummarize
    vcfbreakmulti
    vcfcreatemulti
    vcfevenregions
    vcfcat
    vcfgenosummarize
    vcfgenosamplenames
    vcfgeno2haplo
    vcfleftalign
    vcfcombine
    vcfgeno2alleles
    vcfindex
    vcf2dag
    vcfsample2info
    vcfqual2info
    vcfinfo2qual
    vcfglbound
    vcfinfosummarize
    )

set(SCRIPTS
    bed2region
    bgziptabix
    # plotBfst.R
    # plotHaplotypes.R
    # plotHapLrt.R
    # plotPfst.R
    # plot_roc.r
    # plotSmoothed.R
    # plotWCfst.R
    # plotXPEHH.R
    vcf2bed.py
    vcf2sqlite.py
    vcfbiallelic
    vcfclearid
    vcfclearinfo
    vcfcomplex
    vcffirstheader
    vcfgtcompare.sh
    vcfindelproximity
    vcfindels
    vcfjoincalls
    vcfmultiallelic
    vcfmultiway
    vcfmultiwayscripts
    vcfnobiallelicsnps
    vcfnoindels
    vcfnosnps
    vcfnulldotslashdot
    vcfplotaltdiscrepancy.r
    vcfplotaltdiscrepancy.sh
    vcfplotsitediscrepancy.r
    vcfplottstv.sh
    vcfprintaltdiscrepancy.r
    vcfprintaltdiscrepancy.sh
    vcfqualfilter
    vcfregionreduce
    vcfregionreduce_and_cut
    vcfregionreduce_pipe
    vcfregionreduce_uncompressed
    vcfremovenonATGC
    vcfsnps
    vcfsort
    vcf_strip_extra_headers
    vcfvarstats
    )

# ---- Get version

file (STRINGS "VERSION" BUILD_NUMBER)
add_definitions(-DVCFLIB_VERSION="${BUILD_NUMBER}")
add_definitions(-DVERSION="${BUILD_NUMBER}")

# ---- Build htslib
#
# Note by default we use the distributed htslib! These are
# the old instructions:

if (HTSLIB_LOCAL)

ExternalProject_Add(htslib-build
  SOURCE_DIR ${HTSLIB_LOCAL}
  BINARY_DIR ${HTSLIB_LOCAL}
  PREFIX ${CMAKE_CURRENT_BINARY_DIR}/htslib
  CONFIGURE_COMMAND ""
  BUILD_COMMAND $(MAKE) lib-static
  INSTALL_COMMAND ""
  )

add_library(htslib STATIC IMPORTED)

set_property(TARGET htslib PROPERTY
  IMPORTED_LOCATION ${HTSLIB_LOCAL}/libhts.a)
add_dependencies(htslib htslib-build)

# If the user wants to configure our HTSlib to build with libddeflate, we need
# to make sure to link against libdeflate as a transitive dependency. To do
# that, pass -DHTSLIB_EXTRA_LIBS="-ldeflate" when configuring the project with
# cmake.
# TODO: Stop vendoring in htslib and just use find_package
set(HTSLIB_EXTRA_LIBS "-lcurl" CACHE STRING "Library flags needed to link with htslib's dependencies, for chosen configuration")
set_property(TARGET htslib PROPERTY INTERFACE_LINK_LIBRARIES ${HTSLIB_EXTRA_LIBS})

endif(HTSLIB_LOCAL)

# ---- Build all

if (NOT BUILD_ONLY_LIB)
  foreach(BIN ${BINS})
    add_executable(${BIN} src/${BIN}.cpp)
    target_include_directories(${BIN} PUBLIC ${TABIXPP_LIBRARIES} ${HTSLIB_INCLUDE_DIRS})
    target_link_libraries(${BIN} vcflib tabixpp -DGIT_VERSION=0.9.0 ${TABIXPP_LIBRARIES} ${HTSLIB_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} ${ZLIB_LIBRARIES} ${LIBLZMA_LIBRARIES} ${BZIP2_LIBRARIES})
  endforeach(BIN ${BINS})
  install(TARGETS ${BINS} RUNTIME DESTINATION bin)

  # ---- Copy scripts
  foreach(SCRIPT ${SCRIPTS})
    install(PROGRAMS ./scripts/${SCRIPT} DESTINATION bin RENAME ${SCRIPT})
  endforeach(SCRIPT ${SCRIPTS})

endif()

enable_testing()

# ---- Test

add_test(
    NAME RunTests
    COMMAND "make"
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/test
)

function(add_pytest TEST_FILE)
  add_test(
      NAME ${TEST_FILE}
      COMMAND python3 pytest/${TEST_FILE}.py
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/test
  )
endfunction()

function(add_pydoctest TEST_FILE)
  add_test(
      NAME ${TEST_FILE}
      COMMAND python3 -m doctest -o NORMALIZE_WHITESPACE -o REPORT_UDIFF pytest/${TEST_FILE}.md
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/test
  )
endfunction()

function(add_doctest TEST_FILE)
  add_test(
      NAME ${TEST_FILE}
      COMMAND python3 -m doctest -o NORMALIZE_WHITESPACE -o REPORT_UDIFF ../${TEST_FILE}.md
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/test
  )
endfunction()

function(add_pydoctest_fullname TEST_FILE)
  add_test(
      NAME ${TEST_FILE}
      COMMAND python3 -m doctest -o NORMALIZE_WHITESPACE -o REPORT_UDIFF ${TEST_FILE}
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/test
  )
endfunction()

# add_pytest(vcf2tsv-test)
add_pydoctest(vcf2tsv)
add_pydoctest(vcfnulldotslashdot)
add_doctest(doc/vcfintersect)
add_doctest(doc/vcffilter)
# add_pydoctest_fullname(../README.md)

# ---- Build docs
#
# Generates man pages for the python doctests. Don't need
# to run every time so it is a separate command. For pandoc logic see
# https://www.howtogeek.com/682871/how-to-create-a-man-page-on-linux/
#
# cmake --build . --target man ; cmake --install .

find_program(PANDOC pandoc)

if (PANDOC)
    # note the option ALL which allows to build the docs together with the application
    add_custom_target( man
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        COMMAND ${PANDOC} ./test/pytest/vcfnulldotslashdot.md -s -t man -o ./man/vcfnulldotslashdot.1
        COMMAND ruby ./test/scripts/bin2md.rb --man test/scripts/bin2md-template.erb
        COMMAND ruby ./test/scripts/bin2md.rb --man --index
        COMMAND ruby ./test/scripts/md2man
        # regenerate to allow for URLs in markdown docs
        COMMAND ruby ./test/scripts/bin2md.rb test/scripts/bin2md-template.erb
        COMMAND ruby ./test/scripts/bin2md.rb --index
    )
else (PANDOC)
  message("Pandoc needs to be installed to generate the man pages")
endif (PANDOC)

# ---- Install

install(TARGETS vcflib ARCHIVE DESTINATION lib)

install(FILES ${INCLUDES} DESTINATION include)

install(DIRECTORY ${CMAKE_SOURCE_DIR}/man/ DESTINATION ${CMAKE_INSTALL_PREFIX}/man/man1)

=== debian/changelog ===
libvcflib (1.0.3+dfsg-2) unstable; urgency=medium

  * Fix watch file
  * Standards-Version: 4.6.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Fri, 07 Oct 2022 16:26:06 +0200

libvcflib (1.0.3+dfsg-1) unstable; urgency=medium

  [ Andreas Tille ]
  * New upstream version

  [ Sascha Steinbiss ]
  * Team upload.
  * Fix manpage paths.

 -- Sascha Steinbiss <satta@debian.org>  Sun, 20 Feb 2022 19:24:58 +0100

libvcflib (1.0.2+dfsg-5) unstable; urgency=medium

  [ Vagrant Cascadian ]
  * Enable reproducible by avoid to embed the full path in RPATH
    Closes: #1003808

  [ Andreas Tille ]
  * Add missing build dependency on dh addon.

 -- Andreas Tille <tille@debian.org>  Mon, 17 Jan 2022 20:53:03 +0100

libvcflib (1.0.2+dfsg-4) unstable; urgency=medium

  * Install scripts
    Closes: #989014

 -- Andreas Tille <tille@debian.org>  Fri, 24 Dec 2021 10:51:57 +0100

libvcflib (1.0.2+dfsg-3) unstable; urgency=medium

  * Fix build with gcc-11
    Closes: #984139
  * Standards-Version: 4.6.0 (routine-update)

 -- Andreas Tille <tille@debian.org>  Wed, 20 Oct 2021 18:33:54 +0200

=== debian/control ===
Source: libvcflib
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               markdown <!nodoc>,
               libtabixpp-dev,
               libbz2-dev,
               libdisorder-dev,
               libsmithwaterman-dev,
               libssw-dev,
               libfastahack-dev,
               pkg-config,
               libgtest-dev <!nocheck>,
               debhelper
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/med-team/libvcflib
Vcs-Git: https://salsa.debian.org/med-team/libvcflib.git
Homepage: https://github.com/vcflib/vcflib
Rules-Requires-Root: no

Package: libvcflib1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: C++ library for parsing and manipulating VCF files
 The Variant Call Format (VCF) is a flat-file, tab-delimited textual format
 intended to concisely describe reference-indexed variations between
 individuals. VCF provides a common interchange format for the description of
 variation in individuals and populations of samples, and has become the defacto
 standard reporting format for a wide array of genomic variant detectors.
 .
 vcflib provides methods to manipulate and interpret sequence variation as it
 can be described by VCF. It is both:
 .
  * an API for parsing and operating on records of genomic variation as it can
    be described by the VCF format,
  * and a collection of command-line utilities for executing complex
    manipulations on VCF files.

Package: libvcflib-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libvcflib1 (= ${binary:Version}),
         libdisorder-dev,
         libfastahack-dev,
         libtabixpp-dev,
         libsmithwaterman-dev,
         libssw-dev
Description: C++ library for parsing and manipulating VCF files (development)
 The Variant Call Format (VCF) is a flat-file, tab-delimited textual format
 intended to concisely describe reference-indexed variations between
 individuals. VCF provides a common interchange format for the description of
 variation in individuals and populations of samples, and has become the defacto
 standard reporting format for a wide array of genomic variant detectors.
 .
 vcflib provides methods to manipulate and interpret sequence variation as it
 can be described by VCF. It is both:
 .
  * an API for parsing and operating on records of genomic variation as it can
    be described by the VCF format,
  * and a collection of command-line utilities for executing complex
    manipulations on VCF files.
 .
 This package contains the static library and the header files.

Package: libvcflib-tools
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         python3:any,
         r-base-core,
         r-cran-plyr,
         r-cran-ggplot2,
         r-cran-gridbase
Suggests: r-cran-pracma
Breaks: libvcflib1 (<= 1.0.0~rc2+dfsg-3)
Replaces: libvcflib1 (<= 1.0.0~rc2+dfsg-3)
Description: C++ library for parsing and manipulating VCF files (tools)
 The Variant Call Format (VCF) is a flat-file, tab-delimited textual format
 intended to concisely describe reference-indexed variations between
 individuals. VCF provides a common interchange format for the description of
 variation in individuals and populations of samples, and has become the defacto
 standard reporting format for a wide array of genomic variant detectors.
 .
 vcflib provides methods to manipulate and interpret sequence variation as it
 can be described by VCF. It is both:
 .
  * an API for parsing and operating on records of genomic variation as it can
    be described by the VCF format,
  * and a collection of command-line utilities for executing complex
    manipulations on VCF files.
 .
 This package contains several tools using the library.

=== debian/watch ===
version=4

opts="uversionmangle=s/-rc/~rc/,repacksuffix=+dfsg,dversionmangle=s/\+dfsg[0-9]*//g,repack,compression=xz" \
  https://github.com/vcflib/vcflib/tags .*/v(\d[-\d.rc]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## libvcflib 1.0.9+dfsg1

=== CMakeLists.txt ===
# For Debian currently with
#
#   cd build
#   cmake -DCMAKE_BUILD_TYPE=RelWithDebInfo -DZIG=OFF -DWFA_GITMODULE=OFF ..
#   make
#   make test
#   make install
#
cmake_minimum_required(VERSION 3.16)
project(vcflib)

set(CMAKE_CXX_STANDARD 17)

include(ExternalProject)
include(FeatureSummary)
include(GNUInstallDirs)

find_package(PkgConfig REQUIRED)
find_package(pybind11 CONFIG)

include(GNUInstallDirs)
include(FindBZip2)
include(FindLibLZMA)
include(FindZLIB)
include(FindCURL) # for htslib

feature_summary(
  FATAL_ON_MISSING_REQUIRED_PACKAGES
  WHAT REQUIRED_PACKAGES_NOT_FOUND)

set(CMAKE_POSITION_INDEPENDENT_CODE ON) # for pybind11

# ---- Options

option(BUILD_DOC "Build documentation" ON)
option(OPENMP "Enable OpenMP" ON) # disabling does not work because of vcfwave
option(PROFILING "Enable profiling" OFF)
option(GPROF "Enable gprof profiling" OFF)
option(ASAN "Use address sanitiser" OFF)
option(ZIG "Set to OFF to disable the zig code" ON)
option(WFA_GITMODULE "Force local git submodule for WFA2LIB" ON) # disable in distros, you may need to add path to WFA_INCLUDE_DIRS

include(CheckIPOSupported) # adds lto
check_ipo_supported(RESULT ipo_supported OUTPUT output)

set(EXTRA_FLAGS " ") # otherwise it injects OFF

# ---- Dependencies

if(OPENMP)
  include(FindOpenMP)
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
endif(OPENMP)

find_package(ZLIB)
set_package_properties(ZLIB PROPERTIES TYPE REQUIRED)
find_package(Threads)
set_package_properties(Threads PROPERTIES TYPE REQUIRED)

pkg_check_modules(HTSLIB htslib)   # Optionally builds from contrib/
pkg_check_modules(TABIXPP tabixpp) # Optionally builds from contrib/

# ---- Build switches
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_INTERPROCEDURAL_OPTIMIZATION ${ipo_supported})

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING
          "Choose the type of build, options are: Release|Debug|RelWithDebInfo (for distros)." FORCE)
endif()

if (${CMAKE_BUILD_TYPE} MATCHES Release)
  set(EXTRA_FLAGS "-march=native -D_FILE_OFFSET_BITS=64")
  # set(CMAKE_CXX_FLAGS_RELEASE "-DNDEBUG") # reset CXX_FLAGS to replace -O3 with -Ofast
endif()

if ((${CMAKE_BUILD_TYPE} MATCHES Release) OR (${CMAKE_BUILD_TYPE} MATCHES RelWithDebInfo))
  set (CMAKE_C_FLAGS "${OpenMP_C_FLAGS} ${EXTRA_FLAGS}")
  set (CMAKE_CXX_FLAGS "${OpenMP_CXX_FLAGS} ${EXTRA_FLAGS}")
endif ()

if (${CMAKE_BUILD_TYPE} MATCHES "Debug")
  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${EXTRA_FLAGS}")
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_FLAGS}")
  add_definitions(-Wfatal-errors)
endif ()

if (ASAN)
  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address  -fno-omit-frame-pointer -fno-common")
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address  -fno-omit-frame-pointer -fno-common")
endif(ASAN)

if(PROFILING)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g")
endif(PROFILING)

if(GPROF)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pg")
endif(GPROF)

if (ZIG)
  find_program(ZIG_EXE NAMES "zig")
  if (NOT ZIG_EXE)
    MESSAGE(FATAL_ERROR "zig binary not found in PATH. zig is used for vcfcreatemulti's latest features. Either use cmake -DZIG=OFF option or add zig to the PATH")
  endif (NOT ZIG_EXE)
endif(ZIG)

# ---- Include files

include_directories(include)
include_directories(contrib/fastahack)
include_directories(contrib/intervaltree)
include_directories(contrib/smithwaterman)
include_directories(contrib/multichoose)
include_directories(contrib/filevercmp)
include_directories(contrib/c-progress-bar)

if(NOT HTSLIB_FOUND)
  set(HTSLIB_LOCAL contrib/tabixpp/htslib)
  set(TABIX_FOUND OFF) # also build tabixpp if htslib is missing
endif()

if (NOT TABIX_FOUND)
  set(TABIXPP_LOCAL contrib/tabixpp)
  include_directories(contrib/tabixpp)
  set(tabixpp_SOURCE
    contrib/tabixpp/tabix.cpp
  )
endif()

if(WFA_GITMODULE)
  set(WFA_LOCAL contrib/WFA2-lib)
endif()

file(GLOB INCLUDES
  src/*.h*
  contrib/multichoose/*.h*
  contrib/intervaltree/*.h*
  contrib/smithwaterman/*.h*
  contrib/fastahack/*.h*
  contrib/filevercmp/*.h*
  )

set(vcflib_SOURCE
    src/vcf-c-api.cpp
    src/legacy.cpp
    src/vcf-wfa.cpp
    src/Variant.cpp
    src/rnglib.cpp
    src/var.cpp
    src/pdflib.cpp
    src/cdflib.cpp
    src/split.cpp
    src/legacy.cpp
    src/rkmh.cpp
    src/murmur3.cpp
    src/LeftAlign.cpp
    src/cigar.cpp
    src/allele.cpp
    contrib/fastahack/Fasta.cpp
    contrib/smithwaterman/SmithWatermanGotoh.cpp
    contrib/smithwaterman/Repeats.cpp
    contrib/smithwaterman/IndelAllele.cpp
    contrib/smithwaterman/disorder.cpp
    contrib/smithwaterman/LeftAlign.cpp
    contrib/fsom/fsom.c
    contrib/filevercmp/filevercmp.c
    contrib/c-progress-bar/progress.c
)

if (TABIXPP_LOCAL) # add the tabixpp source file
    list(APPEND vcflib_SOURCE ${tabixpp_SOURCE})
endif()

add_library(vcflib STATIC
    ${vcflib_SOURCE}
    )

set(BINS
    vcfecho
    dumpContigsFromHeader
    bFst
    pVst
    hapLrt
    popStats
    wcFst
    iHS
    segmentFst
    segmentIhs
    genotypeSummary
    sequenceDiversity
    pFst
    smoother
    vcfld
    plotHaps
    abba-baba
    permuteGPAT++
    permuteSmooth
    normalize-iHS
    meltEHH
    vcfnullgenofields
    vcfaltcount
    vcfhetcount
    vcfhethomratio
    vcffilter
    vcf2tsv
    vcfgenotypes
    vcfannotategenotypes
    vcfcommonsamples
    vcfremovesamples
    vcfkeepsamples
    vcfsamplenames
    vcfgenotypecompare
    vcffixup
    vcfclassify
    vcfsamplediff
    vcfremoveaberrantgenotypes
    vcfrandom
    vcfparsealts
    vcfstats
    vcfflatten
    vcfprimers
    vcfnumalt
    vcfcleancomplex
    vcfintersect
    vcfannotate
    vcfallelicprimitives
    vcfwave
    vcfoverlay
    vcfaddinfo
    vcfkeepinfo
    vcfkeepgeno
    vcfafpath
    vcfcountalleles
    vcflength
    vcfdistance
    vcfrandomsample
    vcfentropy
    vcfglxgt
    vcfroc
    vcfcheck
    vcfstreamsort
    vcfuniq
    vcfuniqalleles
    vcfremap
    vcf2fasta
    vcfsitesummarize
    vcfbreakmulti
    vcfevenregions
    vcfcat
    vcfgenosummarize
    vcfgenosamplenames
    vcfgeno2haplo
    vcfleftalign
    vcfcombine
    vcfgeno2alleles
    vcfindex
    vcf2dag
    vcfsample2info
    vcfqual2info
    vcfinfo2qual
    vcfglbound
    vcfinfosummarize
    vcfcreatemulti
)

set(SCRIPTS
    bed2region
    bgziptabix
    vcf2bed.py
    vcf2sqlite.py
    vcfbiallelic
    vcfclearid
    vcfclearinfo
    vcfcomplex
    vcffirstheader
    vcfgtcompare.sh
    vcfindelproximity
    vcfindels
    vcfjoincalls
    vcfmultiallelic
    vcfmultiway
    vcfmultiwayscripts
    vcfnobiallelicsnps
    vcfnoindels
    vcfnosnps
    vcfnulldotslashdot
    vcfplotaltdiscrepancy.r
    vcfplotaltdiscrepancy.sh
    vcfplotsitediscrepancy.r
    vcfplottstv.sh
    vcfprintaltdiscrepancy.r
    vcfprintaltdiscrepancy.sh
    vcfqualfilter
    vcfregionreduce
    vcfregionreduce_and_cut
    vcfregionreduce_pipe
    vcfregionreduce_uncompressed
    vcfremovenonATGC
    vcfsnps
    vcfsort
    vcf_strip_extra_headers
    vcfvarstats
    )

# ---- Get version

file (STRINGS "VERSION" BUILD_NUMBER)
add_definitions(-DVCFLIB_VERSION="${BUILD_NUMBER}")
add_definitions(-DVERSION="${BUILD_NUMBER}")

# ---- Build htslib
#
# Note by default we use the distributed htslib! These are
# the older instructions which allow for a local build from
# git submodules

if (HTSLIB_LOCAL)

  include_directories(${HTSLIB_LOCAL})

  set(flags "-O2 -g -fPIC")
  ExternalProject_Add(htslib-EXT
    SOURCE_DIR "${CMAKE_SOURCE_DIR}/${HTSLIB_LOCAL}"
    UPDATE_COMMAND autoreconf -i
    CONFIGURE_COMMAND ./configure --disable-s3
    INSTALL_COMMAND ""
    BUILD_IN_SOURCE ON
    BUILD_COMMAND $(MAKE) CFLAGS=${flags} lib-static
  )
  ExternalProject_Get_property(htslib-EXT SOURCE_DIR)
  ExternalProject_Get_property(htslib-EXT INSTALL_DIR)
  set(htslib_INCLUDE "${SOURCE_DIR}")
  set(htslib_static "${SOURCE_DIR}/libhts.a")
  set(htslib_lib "${htslib_static}")
  set(HTSLIB_LINK_LIBRARIES "${htslib_static}")

  add_custom_target(htslib
    DEPENDS htslib-EXT
    VERBATIM)

  # set_property(TARGET htslib PROPERTY IMPORTED_LOCATION ${hstlib_lib})
  # add_dependencies(htslib htslib-EXT)

  add_library(HTSLIB_LIBRARIES STATIC IMPORTED)
  set_target_properties(HTSLIB_LIBRARIES PROPERTIES IMPORTED_LOCATION ${htslib_lib})
  add_dependencies(HTSLIB_LIBRARIES htslib-EXT)

# If the user wants to configure our HTSlib to build with libddeflate, we need
# to make sure to link against libdeflate as a transitive dependency. To do
# that, pass -DHTSLIB_EXTRA_LIBS="-ldeflate" when configuring the project with
# cmake.
# TODO: Stop vendoring in htslib and just use find_package

  # set(HTSLIB_EXTRA_LIBS "-lcurl" CACHE STRING "Library flags needed to link with htslib's dependencies, for chosen configuration")
  # set_property(TARGET htslib PROPERTY INTERFACE_LINK_LIBRARIES ${HTSLIB_EXTRA_LIBS})

endif(HTSLIB_LOCAL)

if(WFA_GITMODULE)
  set(WFA_INCLUDE_DIRS ${WFA_LOCAL})
  add_subdirectory(${WFA_LOCAL} EXCLUDE_FROM_ALL)
  set(WFALIB wfa2) # pick up the wfa2 lib target from the included CMakeLists.txt
else(WFA_GITMODULE)
  set(WFA_INCLUDE_DIRS ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_INCLUDEDIR}/wfa2lib)
  find_library(WFALIB wfa2 wfa) # distro search for shared lib
  if(NOT WFALIB)
    message(STATUS "ERROR: Can not find libfwa! Make sure it is installed or use the git submodule instead")
  endif()
endif(WFA_GITMODULE)

include_directories(${WFA_INCLUDE_DIRS})
MESSAGE(STATUS "WFA using include ${WFA_INCLUDE_DIRS}")

# ZIG VCF imported library is part of VCFLIB source tree. We designate it an
# external project so we can run 'zig build'

if (ZIG)
ExternalProject_Add(ZIG-EXT
    SOURCE_DIR "${CMAKE_SOURCE_DIR}/src/zig"
    UPDATE_COMMAND ""
    CONFIGURE_COMMAND ""
    INSTALL_COMMAND ""
    BUILD_IN_SOURCE ON
    BUILD_ALWAYS ON
    BUILD_COMMAND ${CMAKE_SOURCE_DIR}/src/zig/compile.sh # -Drelease-fast=true -freference-trace
)
ExternalProject_Get_property(ZIG-EXT SOURCE_DIR)
set(ZIG_INCLUDE_DIRS ${SOURCE_DIR})
set(ZIG_LINK_LIBRARIES ${SOURCE_DIR}/zig-out/lib/libzig.a)

add_library(ZIGCPP_STATIC_LIB STATIC IMPORTED)
set_target_properties(ZIGCPP_STATIC_LIB PROPERTIES IMPORTED_LOCATION ${ZIG_LINK_LIBRARIES})
add_dependencies(ZIGCPP_STATIC_LIB ZIG-EXT vcf.zig)

include_directories(${ZIG_INCLUDE_DIRS})

else (ZIG)
  set (ZIG_LINK_LIBRARIES )
  add_definitions(-DNO_ZIG=1)
endif (ZIG)

set(vcflib_DEPS
  CURL::libcurl
  )

if (ZIG)
  list(APPEND vcflib_DEPS ZIG-EXT)
endif ()

if (HTSLIB_LOCAL)
  list(APPEND vcflib_DEPS htslib)
endif()

set(vcflib_LIBS
  ${HTSLIB_LIBRARIES}
  ${CURL_LIBRARIES}
  ${ZLIB_LIBRARIES}
  ${LIBLZMA_LIBRARIES}
  ${BZIP2_LIBRARIES}
  ${TABIXPP_LIBRARIES}
  ${CMAKE_THREAD_LIBS_INIT}
  ${WFA_LINK_LIBRARIES}
  ${HTSLIB_LINK_LIBRARIES}
)

if (ZIG)
  list(APPEND vcflib_LIBS ${ZIG_LINK_LIBRARIES})
endif()

add_dependencies(vcflib ${vcflib_DEPS})

# ---- Build all

if (NOT BUILD_ONLY_LIB)
  foreach(BIN ${BINS})
    add_executable(${BIN} src/${BIN}.cpp)
    add_dependencies(${BIN} vcflib)
    target_link_libraries(${BIN} PUBLIC ${vcflib_LIBS} vcflib)
  endforeach(BIN ${BINS})
  # These binaries include WFALIB
  target_link_libraries(vcfallelicprimitives PUBLIC ${WFALIB})
  target_link_libraries(vcfcleancomplex PUBLIC ${WFALIB})
  target_link_libraries(vcfparsealts PUBLIC ${WFALIB})
  target_link_libraries(vcfroc PUBLIC ${WFALIB})
  target_link_libraries(vcfstats PUBLIC ${WFALIB})
  target_link_libraries(vcfwave PUBLIC ${WFALIB})
  install(TARGETS ${BINS} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

  # ---- Copy scripts
  foreach(SCRIPT ${SCRIPTS})
    install(PROGRAMS ./scripts/${SCRIPT} DESTINATION ${CMAKE_INSTALL_BINDIR} RENAME ${SCRIPT})
  endforeach(SCRIPT ${SCRIPTS})

endif()

# ---- Python bindings - mostly for testing at this stage
pybind11_add_module(pyvcflib "${CMAKE_SOURCE_DIR}/src/pythonffi.cpp")
add_dependencies(pyvcflib ${vcflib_DEPS})
target_link_libraries(pyvcflib PUBLIC vcflib ${vcflib_LIBS} ${WFALIB})

=== debian/changelog ===
libvcflib (1.0.9+dfsg1-3build1) noble; urgency=medium

  * No-change rebuild against libtabixpp0t64.

 -- Colin Watson <cjwatson@ubuntu.com>  Sun, 14 Apr 2024 19:01:17 +0100

libvcflib (1.0.9+dfsg1-3) unstable; urgency=medium

  * add support for loong64 arch
    Closes: #1057253

 -- Andreas Tille <tille@debian.org>  Sun, 03 Dec 2023 13:29:41 +0100

libvcflib (1.0.9+dfsg1-2) unstable; urgency=medium

  * Source-only upload.

 -- Andreas Tille <tille@debian.org>  Sun, 06 Aug 2023 23:01:54 +0200

libvcflib (1.0.9+dfsg1-1) unstable; urgency=medium

  * Bump SOVERSION due to ABI change
    Closes: #1032557
  * Attempt to use d-shlibs delayed for later once shared and static lib
    are created both
  * Drop unneeded header files with questionable licenses

 -- Andreas Tille <tille@debian.org>  Sun, 23 Jul 2023 10:42:25 +0200

libvcflib (1.0.9+dfsg-1) unstable; urgency=medium

  [ Étienne Mollier ]
  * New upstream version 1.0.9+dfsg
  * d/patches: refresh everything.
  * wfa2_linking: add patch; fix linker errors.

  [ Andreas Tille ]
  * libvcflib-dev: Depends: libwfa2-dev
    Closes: #1031473

 -- Andreas Tille <tille@debian.org>  Sun, 19 Feb 2023 13:54:18 +0100

libvcflib (1.0.7+dfsg-2) unstable; urgency=medium

  * Restrict architectures to 64bit only

 -- Andreas Tille <tille@debian.org>  Tue, 07 Feb 2023 21:10:50 +0100

libvcflib (1.0.7+dfsg-1) unstable; urgency=medium

  [ Andreas Tille ]
  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)
  * Do not support ZIG compiler which is not packaged yet
  * Build-Depends: python3-pybind11, libtabixpp-dev
  * Fix name of upstream download tarball in watch file
  * Versioned Build-Depends: libwfa2-dev (>= 2.3.2)
  * Do not exclude Files that are not in upstream tarball any more
  * New upstream version 1.0.6+dfsg

  [ Nilesh Patra ]
  * d/rules: Set WFA_GITMODULE to OFF
  * Refresh/update patches
  * Add some ext modules that are missed out in the tarball
  * Add rules for getting ext libs to contrib and adding clean rules for
    pruning them off for consecutive clean builds
  * Add build depends on libhts-dev and python3-dev
  * Pass more flags to get past the configure step
  * d/rules: Get tests running, do not install py shared object lib

 -- Andreas Tille <tille@debian.org>  Tue, 07 Feb 2023 18:37:40 +0100

=== debian/control ===
--- 
+++ 
@@ -4,25 +4,29 @@
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
+#               d-shlibs, # Switch to d-shlibs once shared and static lib are built
                cmake,
                markdown <!nodoc>,
                libtabixpp-dev,
                libbz2-dev,
                libdisorder-dev,
+               libhts-dev,
                libsmithwaterman-dev,
                libssw-dev,
                libfastahack-dev,
+               libwfa2-dev,
                pkg-config,
                libgtest-dev <!nocheck>,
-               debhelper
-Standards-Version: 4.6.1
+               python3-dev,
+               python3-pybind11
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/libvcflib
 Vcs-Git: https://salsa.debian.org/med-team/libvcflib.git
 Homepage: https://github.com/vcflib/vcflib
 Rules-Requires-Root: no
 
-Package: libvcflib1
-Architecture: any
+Package: libvcflib2
+Architecture: any-amd64 arm64 loong64 mips64el ppc64el s390x ia64 ppc64 riscv64 sparc64 alpha
 Multi-Arch: same
 Section: libs
 Depends: ${shlibs:Depends},
@@ -43,16 +47,17 @@
     manipulations on VCF files.
 
 Package: libvcflib-dev
-Architecture: any
+Architecture: any-amd64 arm64 loong64 mips64el ppc64el s390x ia64 ppc64 riscv64 sparc64 alpha
 Multi-Arch: same
 Section: libdevel
 Depends: ${misc:Depends},
-         libvcflib1 (= ${binary:Version}),
+         libvcflib2 (= ${binary:Version}),
          libdisorder-dev,
          libfastahack-dev,
          libtabixpp-dev,
          libsmithwaterman-dev,
-         libssw-dev
+         libssw-dev,
+         libwfa2-dev
 Description: C++ library for parsing and manipulating VCF files (development)
  The Variant Call Format (VCF) is a flat-file, tab-delimited textual format
  intended to concisely describe reference-indexed variations between
@@ -71,7 +76,7 @@
  This package contains the static library and the header files.
 
 Package: libvcflib-tools
-Architecture: any
+Architecture: any-amd64 arm64 mips64el ppc64el s390x ia64 ppc64 riscv64 sparc64 alpha
 Depends: ${shlibs:Depends},
          ${misc:Depends},
          python3:any,
@@ -80,8 +85,6 @@
          r-cran-ggplot2,
          r-cran-gridbase
 Suggests: r-cran-pracma
-Breaks: libvcflib1 (<= 1.0.0~rc2+dfsg-3)
-Replaces: libvcflib1 (<= 1.0.0~rc2+dfsg-3)
 Description: C++ library for parsing and manipulating VCF files (tools)
  The Variant Call Format (VCF) is a flat-file, tab-delimited textual format
  intended to concisely describe reference-indexed variations between

=== debian/watch ===
version=4

opts="uversionmangle=s/-rc/~rc/,repacksuffix=+dfsg,dversionmangle=auto,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/vcflib/vcflib/tags .*/v(\d[-\d.rc]+)\.tar\.gz

## libvcflib 1.0.12+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,10 @@
 # For Debian currently with
 #
 #   cd build
-#   cmake -DCMAKE_BUILD_TYPE=RelWithDebInfo -DZIG=OFF -DWFA_GITMODULE=OFF ..
-#   make
-#   make test
-#   make install
+#   cmake -DCMAKE_BUILD_TYPE=RelWithDebInfo -DZIG=OFF ..
+#   cmake --build .
+#   ctest .
+#   cmake --install .
 #
 cmake_minimum_required(VERSION 3.16)
 project(vcflib)
@@ -38,8 +38,7 @@
 option(GPROF "Enable gprof profiling" OFF)
 option(ASAN "Use address sanitiser" OFF)
 option(ZIG "Set to OFF to disable the zig code" ON)
-option(WFA_GITMODULE "Force local git submodule for WFA2LIB" ON) # disable in distros, you may need to add path to WFA_INCLUDE_DIRS
-
+option(WFA_GITMODULE "Force local git submodule for WFA2LIB" OFF) # disabled by default now
 include(CheckIPOSupported) # adds lto
 check_ipo_supported(RESULT ipo_supported OUTPUT output)
 
@@ -76,14 +75,14 @@
 endif()
 
 if ((${CMAKE_BUILD_TYPE} MATCHES Release) OR (${CMAKE_BUILD_TYPE} MATCHES RelWithDebInfo))
-  set (CMAKE_C_FLAGS "${OpenMP_C_FLAGS} ${EXTRA_FLAGS}")
-  set (CMAKE_CXX_FLAGS "${OpenMP_CXX_FLAGS} ${EXTRA_FLAGS}")
+  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${EXTRA_FLAGS}")
+  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_FLAGS}")
 endif ()
 
 if (${CMAKE_BUILD_TYPE} MATCHES "Debug")
   set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${EXTRA_FLAGS}")
   set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_FLAGS}")
-  add_definitions(-Wfatal-errors)
+  add_definitions(-Wfatal-errors) # stop after first error
 endif ()
 
 if (ASAN)
@@ -112,16 +111,26 @@
 include_directories(contrib/fastahack)
 include_directories(contrib/intervaltree)
 include_directories(contrib/smithwaterman)
-include_directories(contrib/multichoose)
+# include_directories(contrib/multichoose) merged with vcflib
 include_directories(contrib/filevercmp)
 include_directories(contrib/c-progress-bar)
 
-if(NOT HTSLIB_FOUND)
+if(HTSLIB_FOUND)
+  list(JOIN HTSLIB_CFLAGS " " HTSLIB_CFLAGS_STRING)
+  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${HTSLIB_CFLAGS_STRING}")
+  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${HTSLIB_CFLAGS_STRING}")
+else(HTSLIB_FOUND)
+  message(STATUS "Using included htslib")
   set(HTSLIB_LOCAL contrib/tabixpp/htslib)
-  set(TABIX_FOUND OFF) # also build tabixpp if htslib is missing
-endif()
-
-if (NOT TABIX_FOUND)
+  set(TABIXPP_FOUND OFF) # also build tabixpp if htslib is missing
+endif()
+
+if(TABIXPP_FOUND)
+  list(JOIN TABIXPP_CFLAGS " " TABIXPP_CFLAGS_STRING)
+  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${TABIXPP_CFLAGS_STRING}")
+  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${TABIXPP_CFLAGS_STRING}")
+else(TABIXPP_FOUND)
+  message(STATUS "Using included tabixpp")
   set(TABIXPP_LOCAL contrib/tabixpp)
   include_directories(contrib/tabixpp)
   set(tabixpp_SOURCE
@@ -135,24 +144,28 @@
 
 file(GLOB INCLUDES
   src/*.h*
-  contrib/multichoose/*.h*
+  # contrib/multichoose/*.h*
   contrib/intervaltree/*.h*
   contrib/smithwaterman/*.h*
   contrib/fastahack/*.h*
   contrib/filevercmp/*.h*
   )
 
+set(vcfwfa_SOURCE
+    src/legacy.cpp # introduces a WFA dependency
+    src/vcf-wfa.cpp
+)
+
 set(vcflib_SOURCE
+    ${vcfwfa_SOURCE}
     src/vcf-c-api.cpp
-    src/legacy.cpp
-    src/vcf-wfa.cpp
     src/Variant.cpp
+    src/canonicalize.cpp
     src/rnglib.cpp
     src/var.cpp
     src/pdflib.cpp
     src/cdflib.cpp
     src/split.cpp
-    src/legacy.cpp
     src/rkmh.cpp
     src/murmur3.cpp
     src/LeftAlign.cpp
@@ -217,16 +230,11 @@
     vcfsamplediff
     vcfremoveaberrantgenotypes
     vcfrandom
-    vcfparsealts
-    vcfstats
     vcfflatten
     vcfprimers
     vcfnumalt
-    vcfcleancomplex
     vcfintersect
     vcfannotate
-    vcfallelicprimitives
-    vcfwave
     vcfoverlay
     vcfaddinfo
     vcfkeepinfo
@@ -238,7 +246,6 @@
     vcfrandomsample
     vcfentropy
     vcfglxgt
-    vcfroc
     vcfcheck
     vcfstreamsort
     vcfuniq
@@ -264,6 +271,16 @@
     vcfinfosummarize
     vcfcreatemulti
 )
+
+
+set(WFBINS # Introduce wavefront dependency
+    vcfallelicprimitives
+    vcfcleancomplex
+    vcfparsealts
+    vcfroc
+    vcfstats
+    vcfwave
+  )
 
 set(SCRIPTS
     bed2region
@@ -359,16 +376,19 @@
 endif(HTSLIB_LOCAL)
 
 if(WFA_GITMODULE)
+  message(STATUS "Using included libwfa")
   set(WFA_INCLUDE_DIRS ${WFA_LOCAL})
-  add_subdirectory(${WFA_LOCAL} EXCLUDE_FROM_ALL)
+  add_subdirectory(${WFA_LOCAL})
   set(WFALIB wfa2) # pick up the wfa2 lib target from the included CMakeLists.txt
 else(WFA_GITMODULE)
+  include_directories($ENV{CMAKE_PREFIX_PATH}/include/wfa2lib)
   set(WFA_INCLUDE_DIRS ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_INCLUDEDIR}/wfa2lib)
-  find_library(WFALIB wfa2 wfa) # distro search for shared lib
-  if(NOT WFALIB)
-    message(STATUS "ERROR: Can not find libfwa! Make sure it is installed or use the git submodule instead")
-  endif()
+  find_library(WFALIB wfa2 wfa REQUIRED) # distro search for shared lib
 endif(WFA_GITMODULE)
+
+# if(NOT WFALIB)
+#   message(STATUS "ERROR: Can not find wfa2lib! Make sure it is installed or use the git submodule instead")
+# endif()
 
 include_directories(${WFA_INCLUDE_DIRS})
 MESSAGE(STATUS "WFA using include ${WFA_INCLUDE_DIRS}")
@@ -439,23 +459,6 @@
     add_dependencies(${BIN} vcflib)
     target_link_libraries(${BIN} PUBLIC ${vcflib_LIBS} vcflib)
   endforeach(BIN ${BINS})
-  # These binaries include WFALIB
-  target_link_libraries(vcfallelicprimitives PUBLIC ${WFALIB})
-  target_link_libraries(vcfcleancomplex PUBLIC ${WFALIB})
-  target_link_libraries(vcfparsealts PUBLIC ${WFALIB})
-  target_link_libraries(vcfroc PUBLIC ${WFALIB})
-  target_link_libraries(vcfstats PUBLIC ${WFALIB})
-  target_link_libraries(vcfwave PUBLIC ${WFALIB})
-  install(TARGETS ${BINS} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
-
-  # ---- Copy scripts
-  foreach(SCRIPT ${SCRIPTS})
-    install(PROGRAMS ./scripts/${SCRIPT} DESTINATION ${CMAKE_INSTALL_BINDIR} RENAME ${SCRIPT})
-  endforeach(SCRIPT ${SCRIPTS})
-
-endif()
-
-# ---- Python bindings - mostly for testing at this stage
-pybind11_add_module(pyvcflib "${CMAKE_SOURCE_DIR}/src/pythonffi.cpp")
-add_dependencies(pyvcflib ${vcflib_DEPS})
-target_link_libraries(pyvcflib PUBLIC vcflib ${vcflib_LIBS} ${WFALIB})
+  foreach(WFBIN ${WFBINS})
+    add_executable(${WFBIN} src/${WFBIN}.cpp ${vcfwfa_SOURCE})
+    add_dependencies(${WFBIN} vcflib)

=== Makefile ===
# Convenience Makefile invokes cmake. See also the README

VCF_LIB_LOCAL:=$(shell pwd)
BUILD_DIR:=$(VCF_LIB_LOCAL)/build
BIN_DIR:=$(VCF_LIB_LOCAL)/bin
LIB_DIR:=$(VCF_LIB_LOCAL)/lib
INC_DIR:=$(VCF_LIB_LOCAL)/include
CMAKE_FLAGS?=

all:
	if [ ! -d $(BUILD_DIR) ]; then mkdir -p $(BUILD_DIR); fi
	cd $(BUILD_DIR); \
		cmake $(CMAKE_FLAGS) -DCMAKE_INSTALL_PREFIX=$(VCF_LIB_LOCAL) $(VCF_LIB_LOCAL); \
		$(MAKE) && $(MAKE) install

openmp:
	CMAKE_FLAGS=-DOPENMP=ON $(MAKE) all

profiling:
	CMAKE_FLAGS=-DPROFILING=ON $(MAKE) all

gprof:
	CMAKE_FLAGS=-DGPROF=ON $(MAKE) all

test: $(BINS)
	@prove -Itests/lib -w tests/*.t

pull:
	git pull

update: pull all

clean:
	rm -f $(BINS) $(OBJECTS)
	rm -rf $(BIN_DIR)
	rm -rf $(LIB_DIR)
	rm -rf $(INC_DIR)

.PHONY: clean all test pre

=== debian/changelog ===
libvcflib (1.0.12+dfsg-1) unstable; urgency=medium

  [ Michael R. Crusoe ]
  * d/control: formally mark this package as 64-bit little-endian only.
    Closes: #1074044

  [ Étienne Mollier ]
  * d/watch: fix capture of pre-releases.
    Somehow, the scraping of Github tags page tended to meddle with the
    version capture, so this change introduces a switch to git mode, in
    addition to modifications to version mangling.
  * no_fsom patch: unfuzz.
  * shared_lib.patch: unfuzz.
  * tabix_linking.patch: unfuzz.
  * use_debian_packaged_fastahack.patch: refresh.
  * use_debian_packaged_libssw.patch: refresh.
  * use_debian_packaged_smithwaterman.patch: unfuzz.
  * wfa2_linking: unfuzz.
  * cmakelists-fixups.patch: new: fix a couple of configure issues.
  * d/libvcflib-tools.install: remove now missing vcfallelicprimitives.
  * d/libvcflib-dev.install: adjust to new target directory.

  [ Charles Plessy ]
  * Build-depend on discount instead of markdown
    Closes: #1073098

  [ Andreas Tille ]
  * New upstream version
  * Standards-Version: 4.7.0 (routine-update)
  * Replace transitional package pkg-config by pkgconf in Build-Depends
    (routine-update)

 -- Andreas Tille <tille@debian.org>  Sun, 16 Feb 2025 14:54:48 +0100

=== debian/control ===
--- 
+++ 
@@ -4,9 +4,11 @@
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
+               architecture-is-64-bit,
+               architecture-is-little-endian,
 #               d-shlibs, # Switch to d-shlibs once shared and static lib are built
                cmake,
-               markdown <!nodoc>,
+               discount <!nodoc>,
                libtabixpp-dev,
                libbz2-dev,
                libdisorder-dev,
@@ -15,18 +17,18 @@
                libssw-dev,
                libfastahack-dev,
                libwfa2-dev,
-               pkg-config,
+               pkgconf,
                libgtest-dev <!nocheck>,
                python3-dev,
                python3-pybind11
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/med-team/libvcflib
 Vcs-Git: https://salsa.debian.org/med-team/libvcflib.git
 Homepage: https://github.com/vcflib/vcflib
 Rules-Requires-Root: no
 
 Package: libvcflib2
-Architecture: any-amd64 arm64 loong64 mips64el ppc64el s390x ia64 ppc64 riscv64 sparc64 alpha
+Architecture: any
 Multi-Arch: same
 Section: libs
 Depends: ${shlibs:Depends},
@@ -47,7 +49,7 @@
     manipulations on VCF files.
 
 Package: libvcflib-dev
-Architecture: any-amd64 arm64 loong64 mips64el ppc64el s390x ia64 ppc64 riscv64 sparc64 alpha
+Architecture: any
 Multi-Arch: same
 Section: libdevel
 Depends: ${misc:Depends},
@@ -76,7 +78,7 @@
  This package contains the static library and the header files.
 
 Package: libvcflib-tools
-Architecture: any-amd64 arm64 mips64el ppc64el s390x ia64 ppc64 riscv64 sparc64 alpha
+Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends},
          python3:any,

=== debian/rules ===
#!/usr/bin/make -f

DH_VERBOSE := 1

include /usr/share/dpkg/default.mk
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export CPPFLAGS=$(shell dpkg-buildflags --get CPPFLAGS)
export HTS_LDFLAGS=$(shell dpkg-buildflags --get LDFLAGS)
export GIT_VERSION=$(DEB_VERSION)

%:
	dh $@ --buildsystem cmake

override_dh_clean:
	dh_clean
	find . -name "*.o" -delete
	rm -f README.html build/
	rm -rf contrib/filevercmp contrib/multichoose contrib/intervaltree

override_dh_auto_clean:
	dh_auto_clean || true

override_dh_auto_configure:
	cp -a debian/ext/* contrib/
	dh_auto_configure -- -DOPENMP=ON -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON -DZIG=OFF -DWFA_GITMODULE=OFF -DHTSLIB_FOUND=ON -DTABIX_FOUND=ON

override_dh_auto_build:
	dh_auto_build
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
	markdown README.md > README.html
endif

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cp obj-${DEB_HOST_GNU_TYPE}/CTestTestfile.cmake test/
	ln -sf obj-${DEB_HOST_GNU_TYPE}/ build
	cd test && ctest .
	cd .. && rm -f build
endif

override_dh_install:
	dh_install
	find debian/lib* -name filevercmp.h -delete
	cp -a debian/ext/filevercmp/filevercmp.h debian/libvcflib-dev/usr/include/vcflib/
	mkdir -p debian/libvcflib-dev/usr/include/intervaltree
	mv debian/libvcflib-dev/usr/include/vcflib/IntervalTree.h debian/libvcflib-dev/usr/include/intervaltree
	# Remove un-needed py so, install in separate binary package when needed
	find debian/ -name 'pyvcflib.cpython*.so' -delete
	# install pkg-config file
	mkdir -p $(CURDIR)/debian/libvcflib-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig
	mv libvcflib.pc $(CURDIR)/debian/libvcflib-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig
	rm -rf debian/*/usr/lib/vcflib/bin/*.R
# Argh, we can't use d-shlibmove since there is no static library
# Use this once this might be available.
#       d-shlibmove --commit \
#                   --multiarch \
#                   --devunversioned \
#                   --exclude-la \
#                   --override s/libdisorder[0-9]*-dev/libdisorder-dev/ \
#                   --override s/libfastahack[0-9]*-dev/libfastahack-dev/ \
#                   --override s/libsmithwaterman[0-9]*-dev/libsmithwaterman-dev/ \
#                   --override s/libtabixpp[0-9]*-dev/libtabixpp-dev/ \
#                   --override s/libwfa2-[0-9]*-dev/libwfa2-dev/ \
#                   --movedev debian/ext/filevercmp/filevercmp.h debian/libvcflib-dev/usr/include/vcflib/ \
#                   --movedev debian/libvcflib-dev/usr/include/vcflib/IntervalTree.h debian/libvcflib-dev/usr/include/intervaltree \
#                   --movedev libvcflib.pc usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
#                   debian/tmp/usr/lib/*/*.so
#       find debian -name "lib*.la" -delete
	for pl in `grep -Rl '#!/usr/bin/env' debian/*/usr/*` ; do \
	    sed -i '1s?^#!/usr/bin/env[[:space:]]\+perl?#!/usr/bin/perl?' $${pl} ; \
	done

override_dh_link:
	dh_link
	for rscript in debian/libvcflib-tools/usr/lib/vcflib/scripts/*.R ; do \
	    scriptname=$$(basename $$rscript) ; \
	    dh_link -p libvcflib-tools usr/lib/vcflib/scripts/$$scriptname usr/lib/R/site-library/vcflib/$$scriptname ; \
	done

override_dh_fixperms:
	dh_fixperms
	chmod -x debian/*/usr/lib/vcflib/scripts/*.R

=== debian/watch ===
version=4

opts="\
	mode=git, \
	repacksuffix=+dfsg, \
	dversionmangle=auto, \
	uversionmangle=s/-([a-zA-Z]+[\d.]*)/~$1/, \
" \
https://github.com/vcflib/vcflib.git \
refs/tags/v@ANY_VERSION@
